#!/usr/bin/env python

from twisted.internet import reactor, protocol
from twisted.protocols import basic

class ChatProtocol(basic.LineReceiver):
	def connectionMade(self):
		print "A client connected"
	
	def dataReceived(self, data):
		sender = str(self.transport.client)
		data = str(data).strip()
		self.factory.sendLine(data,sender)
	
	def connectionLost(self, reason):
		print "A client disconnected"
		self.factory.cli_list.remove(self)

class ChatFactory(protocol.ServerFactory):
	cli_list = []

	def buildProtocol(self, addr):
		p = ChatProtocol()
		p.factory = self
		self.cli_list.append(p)
		return p

	def sendLine(self, data,sender):
		# sort away odders... fscking odders ;)
		if (len(data)%2) == 0 and self.HexTest(data) == 1:
			for client in self.cli_list:
				if sender != str(client.transport.client):
					client.sendLine(data)

	def HexTest(self, data):
		# check if it is an hexstring
		# 1 = TRUE & 0 = FALSE
		try:
			int(data, 16)
			return 1
		except ValueError:
			return 0

if __name__ == '__main__':
	reactor.listenTCP(6978, ChatFactory())
	try:
		print "menot server v0.3"
		reactor.run()
	except KeybordInterrupt:
		reactor.stop()
